=== debian/changelog ===
ros-melodic-flatbuffers (1.1.0-0stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Daniel Stonier <d.stonier@gmail.com>  Sun, 07 Oct 2018 22:03:46 -0000
